/* USB Driver: Internal Interface for request handling
   Copyright (c) 2010 Networked Systems Group, University of Kaiserslautern

This file is part of the Imote2 Bootloader

The driver contains ideas taken from the linux gadget device driver,
licenced under the GPL.

The Bootloader is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

The Bootloader is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef USB_REQUEST_INTERNAL_H
#define USB_REQUEST_INTERNAL_H

#include <inttypes.h>
#include "usb_configuration.h"
#include "usb_request.h"

/** \cond INTERNAL */

/** \addtogroup usbcomm
 * @{
 */
 
/** \file usb_request_internal.h
 * \brief USB Request
 */

void usbRequestComplete(struct UsbEndpoint * ep, struct UsbRequest * req,
	enum UsbRequestStatus status);

void usbHandleDmaRequest(struct UsbEndpoint * ep);

/** @} */

/** \endcond */

#endif

