/* Common Utils
   Copyright (c) 2010 Networked Systems Group, University of Kaiserslautern

This file is part of the Imote2 Bootloader

The Bootloader is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

The Bootloader is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef UTILS_H
#define UTILS_H

#include <inttypes.h>

/** \file utils.h
 * \brief utils for booting, rebooting, ...
 */

/** \brief error routine, defined in barecrt.s */
void error() __attribute__((noreturn,long_call));

void finishDrivers();
void bootPrepare();

void bootTo(void (*entry)()) __attribute__((noreturn));
void reboot() __attribute__((noreturn,naked));

void utilStartBootTimeout(void(*cb)(uint8_t));
void utilStopBootTimeout();

void utilFlashLedStart();
void utilFlashLedStop();

#endif

